<template>
  <div>
    <div>
      <!-- HEADER DE LA VISTA DEL CONTRATO -->
      <div style="margin: 0 4rem" class="padding-top">
        <el-header style="height: auto; margin: 0 2.75rem">
          <el-row :gutter="15">
            <!-- Filtros -->
            <el-col :span="20" :offset="5">
              <el-col :span="9">
                <app-select
                  v-model="filterSelect"
                  :filterArray="allFilters"
                ></app-select>
              </el-col>
              <el-col :span="11">
                <!-- <app-search-filter v-model="textSearch"></app-search-filter> -->
                <el-input
                  class="input-head"
                  placeholder="Buscar"
                  prefix-icon="el-icon-search"
                  v-model="textSearch"
                  @clear="cleanSearch"
                  @keyup.native.enter="filterMaterials"
                  clearable
                ></el-input>
              </el-col>
              <el-col :span="2">
                <el-button
                  @click="filterMaterials"
                  type="primary"
                  :disabled="textSearch == ''"
                  >BUSCAR</el-button
                >
              </el-col>
            </el-col>
          </el-row>

          <!-- Subtítulo -->
          <el-col :span="24">
            <div class="titleSection">Lista de Contratos</div>
          </el-col>

          <!-- Botón nuevo -->
          <div class="text-end" style="margin-top: 3rem">
            <el-button @click="goGenerar()"  type="primary" plain
              >GENERAR ASIENTO <br> <span style="font-size: 11px">(DE AMORTIZACIÓN)</span></el-button
            >
            <el-button @click="goToNewContract('nuevoContrato')" type="primary"
              ><p style="display: block; transform: translateY(8px);">NUEVO CONTRATO<br> <span style="visibility: hidden">(DE AMORTIZACIÓN)</span><p/></el-button
            >
          </div>
        </el-header>
      </div>
    </div>
    <!-- v-loading="loading" :element-loading-text="loadingText" -->
    <div
      v-bind:class="[
        contracts.length == 0 ? 'remove-grid-container' : 'grid-container',
      ]"
      v-loading="loading"
      :element-loading-text="loadingText"
    >
      <el-row
        v-bind:class="[
          contracts.length == 0 ? 'remove-grid-container' : 'grid-container',
        ]"
        v-if="contracts && contracts.length !== 0"
      >
        <el-col
          :style="{ border: contract.borderAddendum }"
          v-for="(contract, index) in contracts"
          :key="index"
          style="margin-bottom: 4rem"
        >
          <el-card :body-style="{ padding: '0px' }" class="bg-gray">
            <el-row :gutter="20">
              <!-- Lado izquierdo -->
              <el-col :span="8" class="bg-white">
                <div
                  class="text-orange"
                  style="margin: 2rem 3rem"
                  v-if="contract.stateContrato !== 'CONTRATO ORIGINAL'"
                >
                  {{ contract.stateContrato }}
                </div>
                <div style="margin: 3rem 3rem 3rem">
                  <div class="title-styles" style="margin-bottom: 3rem">
                    {{ contract.contractName }}
                  </div>

                  <div class="infoToShow__box">
                    <div style="margin: 15px auto; font-size: 18px">
                      <span class="infoToShow__title">
                        <strong>Cod. Registro:</strong>
                      </span>
                      <span style="color: #8f8f8f">{{
                        contract.contractCode
                      }}</span>
                    </div>
                    <div style="margin: 15px auto; font-size: 18px">
                      <span class="infoToShow__title">
                        <strong>Cod. Géminis:</strong>
                      </span>
                      <span style="color: #8f8f8f">{{
                        contract.geminisCode
                      }}</span>
                    </div>
                    <div style="margin: 15px auto; font-size: 18px">
                      <span class="infoToShow__title">
                        <strong>Cod. Proveedor:</strong>
                      </span>
                      <span style="color: #8f8f8f">{{
                        contract.providerCode
                      }}</span>
                    </div>
                    <div style="margin: 15px auto; font-size: 18px">
                      <span class="infoToShow__title">
                        <strong>Tipo de Proveedor:</strong>
                      </span>
                      <span style="color: #8f8f8f">{{
                        contract.providerType
                      }}</span>
                    </div>

                    <div style="margin: 15px auto; font-size: 18px">
                      <span class="infoToShow__title">
                        <strong>N° Contr. Distribuidor:</strong>
                      </span>
                      <span style="color: #8f8f8f">{{
                        contract.contratoDistribuidor
                      }}</span>
                    </div>
                  </div>

                  <div
                    v-if="contract.typeContract !== 'Afiliación'"
                    class="bg-orange-ligth font-general text-white subtitle-styles box-text1"
                    style="margin-bottom: 1rem; padding: 5px 10px; width: 100%"
                  >
                    Importe Total:
                    <span class="text-white"
                      >{{ contract.currencySymbol }}
                      {{ contract.totalAmount }}</span
                    >
                  </div>
                  <!-- vigencia -->
                  <el-table
                    :data="contracts[index].validity"
                    size="medium"
                    style="margin-top: 3rem"
                    :header-cell-class-name="tableRowClassName"
                  >
                    <el-table-column label="VIGENCIA">
                      <el-table-column label="Inicio">
                        <template slot-scope="scope">
                          <div style="margin-left: 10px">
                            {{
                              new Date(
                                scope.row.startValidity
                              ).toLocaleDateString('en-GB')
                            }}
                          </div>
                        </template>
                      </el-table-column>
                      <el-table-column label="Fin" prop="validityEnd">
                        <template slot-scope="scope">
                          <div style="margin-left: 10px">
                            <p>
                              {{
                                new Date(
                                  scope.row.endValidity
                                ).toLocaleDateString('en-GB')
                              }}
                            </p>
                          </div>
                        </template>
                      </el-table-column>
                    </el-table-column>
                  </el-table>
                </div>
              </el-col>
              <!-- Lado derecho  -->

              <el-col :span="16">
                <div style="margin: 1.5rem 3rem 1.5rem 2rem">
                  <div class="text-end">
                    <el-button
                      v-if="contract.canceledStatus"
                      class="border-grey-darken text-dark-gray-2"
                      plain
                      @click="confirmedContractView(contract, 'cancelado')"
                      >CANCELADO</el-button
                    >
                    <el-button
                      v-if="contract.pendingStatus"
                      class="border-orange text-orange"
                      plain
                      @click="confirmedContractView(contract, 'pendiente')"
                      >PENDIENTE</el-button
                    >
                    <el-button
                      v-if="
                        contract.confirmedStatus &&
                        contract.typeContract !== 'Afiliación'
                      "
                      class="border-red text-red"
                      plain
                      @click="changeToAmortizationViewcontract(contract)"
                      >AMORTIZACIÓN</el-button
                    >
                    <el-button
                      v-if="contract.confirmedStatus"
                      class="border-green text-green"
                      plain
                      @click="confirmedContractView(contract, 'confirmado')"
                      >CONFIRMADO</el-button
                    >
                  </div>
                  <h3>MATERIALES</h3>
                  <p class="subtitle-styles" style="margin: 2rem 0">
                    N° de Materiales: {{ contract.refMaterials.length }}
                  </p>
                  <div class="overflow-auto">
                    <el-row
                      style="margin-bottom: 1rem"
                      v-for="(item, index) in contract.refMaterials"
                      :key="index"
                    >
                      <!-- {{ item }} -->
                      <el-col :span="2">
                        <p
                          style="padding: 5px 0"
                          class="bg-dark-gray-2 text-white text-center"
                        >
                          {{ index + 1 }}
                        </p>
                      </el-col>
                      <el-col :span="21" :offset="1" class="bg-white">
                        <el-row>
                          <!-- :span="(contract.typeContract !== 'Afiliación')?11:16" -->
                          <el-col :span="11">
                            <p style="padding: 5px 0.8rem">
                              {{ item.listTitle }}
                            </p>
                          </el-col>
                          <el-col :span="7">
                            <p class="bg-white text-material-type">
                              ({{ item.typeOfContent.substr(0, 3) }})
                            </p>
                          </el-col>
                          <!-- v-if="contract.typeContract !== 'Afiliación'" -->
                          <el-col :span="6">
                            <p
                              style="padding: 5px 0.8rem"
                              class="text-orange"
                              :class="
                                Object(item.numChapters).length > 0
                                  ? 'fw-500'
                                  : ''
                              "
                            >
                              <span v-if="item.unitPrice !== 'Cortesía'">{{
                                item.currencySymbol
                              }}</span>
                              {{ item.unitPrice }}
                            </p>
                          </el-col>
                        </el-row>
                        <!-- && contract.typeContract !== 'Afiliación' -->
                        <el-row
                          v-if="Object(item.numChapters).length > 0"
                          class="bg-white"
                        >
                          <el-row
                            v-for="(tem, index) in item.numChapters"
                            :key="index"
                          >
                            <el-col :span="11">
                              <el-row>
                                <el-col :span="12">
                                  <p style="padding: 5px 0.8rem" class="f-15">
                                    <span class="fw-500">Temp.:</span>
                                    {{ tem.season }}
                                  </p>
                                </el-col>
                                <el-col :span="12">
                                  <p style="padding: 5px 0.8rem" class="f-15">
                                    <span class="fw-500">N° de Cap.:</span>
                                    {{ tem.chapters }}
                                  </p>
                                </el-col>
                              </el-row>
                            </el-col>
                            <el-col :span="7">
                              <p
                                style="padding: 5px 0.8rem; text-align: right"
                                class="f-15"
                              >
                                Precio por Capítulo:
                              </p>
                            </el-col>
                            <el-col :span="6">
                              <!-- {{tem}} -->
                              <p
                                style="padding: 5px 0.8rem"
                                class="text-orange f-15"
                              >
                                <span v-if="tem.chapterPrice !== 'Cortesía'">{{
                                  item.currencySymbol
                                }}</span>
                                {{ tem.chapterPrice }}
                              </p>
                            </el-col>
                            <hr
                              style="border: 0.5px solid #eceaea"
                              v-if="
                                Object.keys(item.numChapters).length - 1 > index
                              "
                            />
                          </el-row>
                        </el-row>
                      </el-col>
                    </el-row>
                  </div>
                  <p
                    v-if="contract.typeContract !== 'Afiliación'"
                    class="text-end"
                    style="margin: 2rem 3rem 0 0"
                  >
                    <strong>
                      Total Materiales:
                      <span
                        style="margin-left: 2rem"
                        v-if="contract.totalAmount !== ''"
                        >{{ contract.currencySymbol }}
                        {{ contract.totalMaterials }}</span
                      >
                      <span
                        style="margin-left: 2rem"
                        v-if="contract.totalAmount == ''"
                        >No ingresado</span
                      >
                    </strong>
                  </p>
                  <p
                    class="text-end igvText"
                    v-if="contract.providerType == 'Local'"
                  >
                    IGV: 18% ({{ contract.currencySymbol }}
                    {{ contract.percentage }})
                  </p>
                </div>
              </el-col>
            </el-row>
          </el-card>
        </el-col>
      </el-row>
      <!-- Tarjeta 'No hay resultado' -->
      <el-row
        v-bind:class="[
          contracts.length == 0 ? 'remove-grid-container' : 'grid-container',
        ]"
        v-if="isShowNoResults"
      >
        <el-col :span="20" :offset="2">
          <el-card :body-style="{ padding: '0px' }" class="bg-gray">
            <el-col :span="8" style="margin-top: 1rem" class="text-center">
              <img src="@/assets/images/detective.svg" alt />
            </el-col>
            <el-col :span="16">
              <div style="margin-top: 5rem">
                <p class="title-styles">¡Lo sentimos!</p>
                <p class="title-styles">
                  No encontramos resultados para tu búsqueda
                </p>
              </div>
            </el-col>
          </el-card>
        </el-col>
      </el-row>
    </div>
  </div>
</template>
<script>
import { modifyText } from '@/utils/modifyText.js'
import SearchFilter from '@/components/searchFilter.vue'
import Select from '@/components/AppSelect.vue'
import { mapState } from 'vuex'
import { HTTP } from '@/main.js'
  /**
  * @vue-data {Array} allFilters - Lista de los filtros para las busquedas de un contrato
  * @vue-computed {Array} contracts - Lista de los contratos filtrados por tipo de usuario
  */
export default {
  components: {
    'app-search-filter': SearchFilter,
    'app-select': Select,
  },
  data() {
    return {
      filterSelect: '', //select
      textSearch: '', //buscador
      allFilters: [
        { value: 'contractCode', label: 'Código Registro' },
        { value: 'providerCode', label: 'Código Proveedor' },
        { value: 'codMaterial', label: 'Código Material' },
        { value: 'startValidity', label: 'Vigencia - Inicio' },
        { value: 'endValidity', label: 'Vigencia - Fin' },
      ],
      code: '', // para generar código de contrato
      loading: true,
      isShowNoResults: false,
      IsClick: false,
      allContracts: [],
    }
  },
  computed: {
    ...mapState({
      loadingText: (state) => state.textLoadingContracts,
    }),
    contracts() {
      return !this.IsClick ? this.allContracts : this.searchContracts
    },
    importTotal() {
      return this.contract.totalAmount !== ''
        ? 'No ingresado'
        : this.contract.currencySymbol + ' ' + this.contract.totalAmount
    },
  },
  created() {
    this.getContract()
  },
  methods: {
    goGenerar() {
      this.$router.push('asiento')
    },
    /** Trae la lista e todos los contratos*/
    getContract() {
      this.loading = true
      HTTP.get('contracts').then((res) => {
        this.allContracts = res.data.contracts
        this.loading = !this.allContracts.length > 0
      })
    },
    /** Filtra los contratos dependiendo de la referencia enviada */
    filterMaterials() {
      let cadenaConexion

      if (
        this.filterSelect == 'startValidity' ||
        (this.filterSelect == 'endValidity' && this.textSearch !== '')
      ) {
        var myDate = this.textSearch
        myDate = myDate.split('/')
        var newDate = myDate[1] + '/' + myDate[0] + '/' + myDate[2]
        var timestamp = new Date(newDate).getTime()
        cadenaConexion = HTTP.get(
          `contracts/typeOfFilter/${this.filterSelect}/word/${timestamp}`
        )
      } else if (this.filterSelect == '' && this.textSearch !== '') {
        cadenaConexion = HTTP.get(
          `contracts/typeOfFilter/contractName/word/${this.textSearch}`
        )
      } else {
        cadenaConexion = HTTP.get(
          `contracts/typeOfFilter/${this.filterSelect}/word/${this.textSearch}`
        )
      }
      cadenaConexion.then((res) => {
        this.isShowNoResults = res.data.contracts.length == 0 ? true : false
        // this.$store.dispatch('SELECTED_PROGRAMS', res.data.contracts)
        this.searchContracts = res.data.contracts
        this.IsClick = true
      })
    },
    /** Borra los datos escritos en el friltro */
    cleanSearch() {
      this.filterSelect = ''
      this.isShowNoResults = false
      this.IsClick = false
    },
    //bóton de nuevo contrato
    goToNewContract(nuevo) {
      this.$store.dispatch('setItemInConfirmedContract', nuevo)
      // this.$localStorage.set('stateAdendum', JSON.stringify(nuevo))
      this.$router.push({ name: 'newContract' })
    },
    tableRowClassName({ row, rowIndex }) {
      if (rowIndex === 0) {
        return 'first-row-header'
      }
      if (rowIndex === 1) {
        return 'second-row-header'
      }
    },
    /** Trae los datos de las amortizaciones y esquemas de los materiales del contrato y envia a la vista de amortizacion
    * @param {Object} contract - Objeto con los datos del contrato
    */
    async changeToAmortizationViewcontract(contract) {
      const { data } = await HTTP.get(
        `amortization/ofContract/${contract.geminisCode}`
      )

      this.$localStorage.set('contractAmort', JSON.stringify(data))
      this.$localStorage.set('amortContract', JSON.stringify(contract))

      this.$router.push({ name: 'amortizationContract' })
    },
    /** Trae los datos del contrato al que se quiere ingresar y se entra a la vista con los datos del contrato
    * @param {Object} contract - Objeto que trae todos los datos del contrato
    * @param {String} estado - Estado del contrato, si es pendiente, confirmado o anulado
    */
    confirmedContractView(contract, estado) {
      console.log(contract)
      this.$store.dispatch('setContract', contract)
      this.$store.dispatch('setContractOriginal', contract)
      this.$store.dispatch('setContractStatus', estado)
      this.$router.push({ name: 'confirmedContract' })
    },
    verifyContent() {
      if (this.$store.state.contracts.length > 0) {
        this.loading = false
      } else {
        this.loading =
          this.$store.state.contracts.length == 0 && this.textSearch !== ''
            ? false
            : true
      }
    },
  },
  beforeDestroy() {
    this.$store.commit('updateTexContracts', 'Cargando Contratos...')
  },
}
</script>


<style scoped>
.titleSection {
  background: #4a4a4a;
  color: white;
  padding: 10px 10px 10px 35px;
  text-transform: uppercase;
  font-weight: 400;
  margin: 40px auto;
  font-size: 18px;
}
.text-material-type {
  padding: 5px 0.8rem;
  color: #828282;
  text-transform: uppercase;
  text-align: right;
}
.f-15 {
  font-size: 15px;
}
.fw-500 {
  font-weight: 500;
}

.igvText {
  margin: 0.5rem 3rem 0 0;
  color: #828282;
  font-weight: 500;
}
</style>